﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Editors;
using System.Windows.Interactivity;
using System.Collections.Specialized;
using System.Collections;

namespace TestMultiColumnComboEditor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        CheckBox myCheckBox = null;


        private void checkBox1_Loaded(object sender, RoutedEventArgs e)
        {
            myCheckBox = sender as CheckBox;
        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            if (MyComboEditor.SelectedItems.Count != MyComboEditor.Items.Count)
            {
                MyComboEditor.SelectedItems.Clear();
                foreach (var item in MyComboEditor.Items)
                {
                    MyComboEditor.SelectedItems.Add(item.Data);
                }
            } 
        }

        private void CheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            MyComboEditor.SelectedItems.Clear();
        }

        private void xamMultiColumnComboEditor1_SelectionChanged(object sender, EventArgs e)
        {
            if ((sender as XamMultiColumnComboEditor).SelectedItems.Count == 0)
            {
                myCheckBox.IsChecked = false;
            }
            if ((sender as XamMultiColumnComboEditor).SelectedItems.Count == (sender as XamMultiColumnComboEditor).Items.Count)
            {
                myCheckBox.IsChecked = true;
            }
        }
    }

    public class XamComboEditorSelectedItemsBehavior : Behavior<XamMultiColumnComboEditor>
    {
        public static readonly DependencyProperty SelectedItemsProperty =
            DependencyProperty.Register("SelectedItems", typeof(INotifyCollectionChanged), typeof(XamComboEditorSelectedItemsBehavior), new PropertyMetadata(OnSelectedItemsPropertyChanged));

        private XamMultiColumnComboEditor Combobox
        {
            get
            {
                return AssociatedObject as XamMultiColumnComboEditor;
            }
        }

        public INotifyCollectionChanged SelectedItems
        {
            get
            {
                return (INotifyCollectionChanged)GetValue(SelectedItemsProperty);
            }
            set
            {
                SetValue(SelectedItemsProperty, value);
            }
        }

        private static void OnSelectedItemsPropertyChanged(DependencyObject target, DependencyPropertyChangedEventArgs args)
        {
            var collection = args.NewValue as INotifyCollectionChanged;
            if (collection != null)
            {
                collection.CollectionChanged += ((XamComboEditorSelectedItemsBehavior)target).ContextSelectedItems_CollectionChanged;
            }
        }

        protected override void OnAttached()
        {
            base.OnAttached();

            Combobox.SelectedItems.CollectionChanged += new NotifyCollectionChangedEventHandler(SelectedItems_CollectionChanged);
        }

        void ContextSelectedItems_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
        {
            UnsubscribeFromEvents();

            Transfer(SelectedItems as IList, Combobox.SelectedItems);

            SubscribeToEvents();
        }

        void SelectedItems_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            UnsubscribeFromEvents();

            Transfer(Combobox.SelectedItems, SelectedItems as IList);

            SubscribeToEvents();
        }

        private void SubscribeToEvents()
        {
            Combobox.SelectedItems.CollectionChanged += SelectedItems_CollectionChanged;

            if (SelectedItems != null)
            {
                SelectedItems.CollectionChanged += ContextSelectedItems_CollectionChanged;
            }
        }

        private void UnsubscribeFromEvents()
        {
            Combobox.SelectedItems.CollectionChanged -= SelectedItems_CollectionChanged;

            if (SelectedItems != null)
            {
                SelectedItems.CollectionChanged -= ContextSelectedItems_CollectionChanged;
            }
        }

        public static void Transfer(IList source, IList target)
        {
            if (source == null || target == null)
                return;

            target.Clear();

            foreach (var o in source)
            {
                target.Add(o);
            }
        }
    }
}
