﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Input;
using Microsoft.Practices.Prism.Commands;
using Microsoft.Practices.Prism.Mvvm;

namespace TestMultiColumnComboEditor
{
    public class Item
    {
        public int Id { get; set; }

        public String Symbol { get; set; }
    }



    public class ViewModel : BindableBase
    {
        private List<Item> _data = new List<Item>();

        public List<Item> Data
        {
            get { return _data; }
            set { SetProperty(ref this._data, value); }
        }

        private ObservableCollection<Item> _selectedItems = new ObservableCollection<Item>();
        public ObservableCollection<Item> SelectedItems
        {
            get { return _selectedItems; }
            set { SetProperty(ref this._selectedItems, value); }
        }

        public ICommand ShowSelecteds { get; set; }

        private void ShowSelectedsHandler()
        {
            String msg = String.Empty;
            foreach (var item in SelectedItems)
            {

                msg = msg + item.Symbol + " ";
            }
            MessageBox.Show(msg);
        }


        public ViewModel()
        {
            _data.Add(new Item() { Id = 1, Symbol = "asdasd" });
            _data.Add(new Item() { Id = 3, Symbol = "qweqwe" });
            _data.Add(new Item() { Id = 3, Symbol = "zxczxc" });

            ShowSelecteds = new DelegateCommand(ShowSelectedsHandler);
        }
    }
}
